/*
 * Spreed WebRTC.
 * Copyright (C) 2013-2015 struktur AG
 *
 * This file is part of Spreed WebRTC.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

!function(){var e="presentation",t=function(e){var t={draw:"urn:oasis:names:tc:opendocument:xmlns:drawing:1.0",presentation:"urn:oasis:names:tc:opendocument:xmlns:presentation:1.0",text:"urn:oasis:names:tc:opendocument:xmlns:text:1.0",office:"urn:oasis:names:tc:opendocument:xmlns:office:1.0"};return t[e]||console.log("prefix ["+e+"] unknown.")},n=(document.getElementsByTagName("body")[0],document.getElementsByTagName("script")[0]),o=n.getAttribute("data-parent-origin"),a=n.getAttribute("data-webodf-url"),s=document.getElementById("container"),i=null,r=null,l=null,c=function(e,t,n){return"string"==typeof e?void l.orig_readFile.call(l,e,t,n):void n(null,new Uint8Array(e))},d=function(e,t){if("string"==typeof e)return void l.orig_loadXML.call(l,e,t);var n=new Blob([new Uint8Array(e)]),o=new FileReader;o.onload=function(e){var n=new DOMParser,o=n.parseFromString(e.target.result,"text/xml");t(null,o)},o.readAsText(n)},u=function(){};u.prototype.getPropertyValue=function(){return null};var m=function(){var e=l.orig_getWindow.apply(l,arguments),t=e.getComputedStyle;return e.getComputedStyle=function(){var n=t.apply(e,arguments);return n||(n=new u),n},e},p=function(e){this.head=document.getElementsByTagName("head")[0],this.canvasDom=document.getElementById("odfcanvas"),this.window=e,this.canvas=null,this.document_type=null};p.prototype.postMessage=function(e,t){var n={type:e};n[e]=t,this.window.parent.postMessage(n,o)},p.prototype.openFile=function(e){if(i)this._doOpenFile(e);else{var t=this;i=document.createElement("script"),i.type="text/javascript",i.src=a,i.onerror=function(){t.postMessage("webodf.error",{msgid:"loadScriptFailed"}),t.head.removeChild(i),i=null},i.onload=function(){console.log("Using webodf.js "+t.window.webodf.Version),r=t.window.odf,l=t.window.runtime,l.orig_readFile=l.readFile,l.readFile=c,l.orig_loadXML=l.loadXML,l.loadXML=d,l.orig_getWindow=l.getWindow,l.getWindow=m,t._doOpenFile(e)},this.head.appendChild(i)}},p.prototype.closeFile=function(){this.canvas&&(this.canvas.destroy(function(){}),this.canvas=null)},p.prototype._doOpenFile=function(e){if(this.postMessage("webodf.loading",{source:e}),!this.canvas){var t=this;this.canvas=new r.OdfCanvas(this.canvasDom),this.canvas.addListener("statereadychange",function(){t._odfLoaded()})}this.canvas.setZoomLevel(1),this.canvas.load(e)},p.prototype._odfLoaded=function(){var n=this.canvas.odfContainer();console.log("ODF loaded",n),this.document_type=n.getDocumentType();var o=[];switch(this.document_type){case e:s.className+=" showonepage",o=n.rootElement.getElementsByTagNameNS(t("draw"),"page");break;default:s.className=this.canvasDom.className.replace(/(?:^|\s)showonepage(?!\S)/g,"")}var a=Math.max(1,o.length);this.postMessage("webodf.loaded",{url:n.getUrl(),type:this.document_type,numPages:a})},p.prototype.showPage=function(e){this.canvas.showPage(e),this.redrawPage()},p.prototype.redrawPage=function(){if(this.canvas)switch(this.document_type){case e:this.canvas.fitToContainingElement(s.offsetWidth,s.offsetHeight);break;default:this.canvas.fitToWidth(s.offsetWidth)}};var g=new p(window);window.addEventListener("message",function(e){if(e.origin===o){var t=e.data,n=t[t.type]||{};switch(t.type){case"openFile":g.openFile(n.source);break;case"closeFile":g.closeFile();break;case"showPage":g.showPage(n.page);break;case"redrawPage":g.redrawPage();break;default:console.log("Unknown message received",e)}}},!1),document.addEventListener("keyup",function(e){g.postMessage("webodf.keyUp",{key:e.keyCode}),e.preventDefault()}),window.addEventListener("resize",function(){g.redrawPage()});var f=function(e){var t=document.fullscreenElement||document.msFullscreenElement||document.mozFullScreenElement||document.webkitFullscreenElement||document.webkitCurrentFullScreenElement;t?document.exitFullscreen?document.exitFullscreen():document.webkitExitFullscreen?document.webkitExitFullscreen():document.mozCancelFullScreen?document.mozCancelFullScreen():document.msExitFullscreen&&document.msExitFullscreen():e.requestFullscreen?e.requestFullscreen():e.webkitRequestFullscreen?e.webkitRequestFullscreen():e.mozRequestFullScreen?e.mozRequestFullScreen():e.msRequestFullscreen&&e.msRequestFullscreen()};s.addEventListener("dblclick",function(){f(s)}),console.log("WebODF sandbox ready."),g.postMessage("ready",{ready:!0})}();